defineObject{
	name = "sx_swinging_door_wooden_01_dungeon",
	placement = "wall",
	components = {
		{
			class = "Model",
			model = "mod_assets/sx_swinging_doors/models/null_door.fbx",
			enabled = false,
		},
		{
			class = "Model",
			name = "frame",
			model = "mod_assets/sx_swinging_doors/models/sx_swinging_door_02_frame.fbx",
			materialOverrides = { ["cemetery_wall"] = "dungeon_wall_01" },
		},
		{
			class = "Model",
			name = "swing",
			model = "mod_assets/sx_swinging_doors/models/sx_swinging_door_02.fbx",
                  staticShadow = true, -- consistent with standard assets doors, also this model includes a frame
                  -- which should definitely have static shadows
		},
		{
			class = "Animation",
			model = "swing",
			--currentLevelOnly = true,
			animations = {
				open = "mod_assets/sx_swinging_doors/animations/sx_swinging_door_02_open.fbx",
				close = "mod_assets/sx_swinging_doors/animations/sx_swinging_door_02_close.fbx",
			},
			onAnimationEvent = function(self, event)
				if event == "begin" then
					self.go.clickable:disable()
					self.go.controller:disable()
					local back = findEntity("bck_"..self.go.id)
					if back and back.clickable then
						back.clickable:disable()
					end
					local openfront = findEntity("oft_"..self.go.id)
					if openfront and openfront.clickable then
						openfront.clickable:disable()
					end
					local openback = findEntity("obk_"..self.go.id)
					if openback and openback.clickable then
						openback.clickable:disable()
					end
				elseif event == "open" then
					self.go.door:setDoorState("open")
				elseif event == "midopen" then
					local openfront = findEntity("oft_"..self.go.id)
					if openfront and openfront.door then
						openfront.door:enable()
					end
				elseif event == "close" then
					self.go.door:setDoorState("close")
					local openfront = findEntity("oft_"..self.go.id)
					if openfront and openfront.door then
						openfront.door:disable()
					end
				elseif event == "finishopen" then
					local openfront = findEntity("oft_"..self.go.id)
					if openfront and openfront.clickable then
						openfront.clickable:enable()
						if openfront.door then
							openfront.door:enable()
						end
					end
					local openback = findEntity("obk_"..self.go.id)
					if openback and openback.clickable then
						openback.clickable:enable()
					end
				elseif event == "end" then
					self.go.clickable:enable()
					self.go.controller:enable()
					local back = findEntity("bck_"..self.go.id)
					if back and back.clickable then
						back.clickable:enable()
					end
				end
			end
		},
		{
			class = "Door",
			sparse = false,
			killPillars = false,
			openSound = "sx_silent",
			closeSound = "sx_silent",
			lockSound = "sx_silent",
		},
		{
			class = "Clickable",
			offset = vec(0,1.375,0),
			size = vec(2.0, 2.0, 0.3),
			onClick = function(self)
				if self.go.door:isClosed() then
					self.go.controller:open()
				else
					self.go.controller:close()
				end
			end
		},
		{
			class = "ItemConstrainBox",
			name = "cbox1",
			size = vec(0.8, 3, 0.7),
			offset = vec(-1.3, 1.5, 0),
		},
		{
			class = "ItemConstrainBox",
			name = "cbox2",
			size = vec(0.8, 3, 0.7),
			offset = vec(1.3, 1.5, 0),
		},
		{
			class = "Controller",
			onOpen = function(self)
				if self.go.door:isClosed() then
					self.go.animation:play("open")
				end
			end,
			onClose = function(self)
				if self.go.door:isOpen() then
					self.go.animation:play("close")
				end
			end,
			onToggle = function(self)
				if self.go.door:isClosed() then
					self:open()
				else
					self:close()
				end
			end,
			onInit = function(self)
				local back = findEntity("bck_"..self.go.id)
				if not back then
					local dx,dy = getForward(self.go.facing)
					local nx,ny = self.go.x+dx,self.go.y+dy
					if nx >= 0 and nx < self.go.map:getWidth() and ny >= 0 and ny < self.go.map:getHeight() then
						back = spawn("sx_urban_town_door_back",self.go.level,nx,ny,(self.go.facing+2)%4,self.go.elevation,"bck_"..self.go.id)
						local openfront = findEntity("oft_"..self.go.id)
						if not openfront then
							openfront = spawn("sx_urban_town_door_02_openfront",self.go.level,nx,ny,(self.go.facing+1)%4,self.go.elevation,"oft_"..self.go.id)
							local openback = findEntity("obk_"..self.go.id)
							if not openback then
								dx,dy = getForward(openfront.facing)
								nx,ny = openfront.x+dx,openfront.y+dy
								if nx >= 0 and nx < self.go.map:getWidth() and ny >= 0 and ny < self.go.map:getHeight() then
									openback = spawn("sx_urban_town_door_openback",self.go.level,nx,ny,(openfront.facing+2)%4,self.go.elevation,"obk_"..self.go.id)
								end
							end
						end
					end
				end
			end,
			onInitialOpen = function(self)
				self:open()
			end,
			onInitialClose = function(self)
				-- nop
			end,
		},
	},
	editorIcon = 16,
	automapIcon = 84,
	dontAdjustHeight = true,
	tags = { "sx_doors" },
}

defineObject{
	name = "sx_swinging_door_wooden_02_dungeon",
	placement = "wall",
	components = {
		{
			class = "Model",
			model = "mod_assets/sx_swinging_doors/models/null_door.fbx",
			enabled = false,
		},
		{
			class = "Model",
			name = "frame",
			model = "mod_assets/sx_swinging_doors/models/sx_swinging_door_02_frame.fbx",
			materialOverrides = { ["cemetery_wall"] = "dungeon_wall_01" },
		},
		{
			class = "Model",
			name = "swing",
			model = "mod_assets/sx_swinging_doors/models/sx_swinging_door_03.fbx",
                  staticShadow = true, -- consistent with standard assets doors, also this model includes a frame
                  -- which should definitely have static shadows
		},
		{
			class = "Animation",
			model = "swing",
			--currentLevelOnly = true,
			animations = {
				open = "mod_assets/sx_swinging_doors/animations/sx_swinging_door_02_open.fbx",
				close = "mod_assets/sx_swinging_doors/animations/sx_swinging_door_02_close.fbx",
			},
			onAnimationEvent = function(self, event)
				if event == "begin" then
					self.go.clickable:disable()
					self.go.controller:disable()
					local back = findEntity("bck_"..self.go.id)
					if back and back.clickable then
						back.clickable:disable()
					end
					local openfront = findEntity("oft_"..self.go.id)
					if openfront and openfront.clickable then
						openfront.clickable:disable()
					end
					local openback = findEntity("obk_"..self.go.id)
					if openback and openback.clickable then
						openback.clickable:disable()
					end
				elseif event == "open" then
					self.go.door:setDoorState("open")
				elseif event == "midopen" then
					local openfront = findEntity("oft_"..self.go.id)
					if openfront and openfront.door then
						openfront.door:enable()
					end
				elseif event == "close" then
					self.go.door:setDoorState("close")
					local openfront = findEntity("oft_"..self.go.id)
					if openfront and openfront.door then
						openfront.door:disable()
					end
				elseif event == "finishopen" then
					local openfront = findEntity("oft_"..self.go.id)
					if openfront and openfront.clickable then
						openfront.clickable:enable()
						if openfront.door then
							openfront.door:enable()
						end
					end
					local openback = findEntity("obk_"..self.go.id)
					if openback and openback.clickable then
						openback.clickable:enable()
					end
				elseif event == "end" then
					self.go.clickable:enable()
					self.go.controller:enable()
					local back = findEntity("bck_"..self.go.id)
					if back and back.clickable then
						back.clickable:enable()
					end
				end
			end
		},
		{
			class = "Door",
			sparse = false,
			killPillars = false,
			openSound = "sx_silent",
			closeSound = "sx_silent",
			lockSound = "sx_silent",
		},
		{
			class = "Clickable",
			offset = vec(0,1.375,0),
			size = vec(2.0, 2.0, 0.3),
			onClick = function(self)
				if self.go.door:isClosed() then
					self.go.controller:open()
				else
					self.go.controller:close()
				end
			end
		},
		{
			class = "ItemConstrainBox",
			name = "cbox1",
			size = vec(0.8, 3, 0.7),
			offset = vec(-1.3, 1.5, 0),
		},
		{
			class = "ItemConstrainBox",
			name = "cbox2",
			size = vec(0.8, 3, 0.7),
			offset = vec(1.3, 1.5, 0),
		},
		{
			class = "Controller",
			onOpen = function(self)
				if self.go.door:isClosed() then
					self.go.animation:play("open")
				end
			end,
			onClose = function(self)
				if self.go.door:isOpen() then
					self.go.animation:play("close")
				end
			end,
			onToggle = function(self)
				if self.go.door:isClosed() then
					self:open()
				else
					self:close()
				end
			end,
			onInit = function(self)
				local back = findEntity("bck_"..self.go.id)
				if not back then
					local dx,dy = getForward(self.go.facing)
					local nx,ny = self.go.x+dx,self.go.y+dy
					if nx >= 0 and nx < self.go.map:getWidth() and ny >= 0 and ny < self.go.map:getHeight() then
						back = spawn("sx_urban_town_door_back",self.go.level,nx,ny,(self.go.facing+2)%4,self.go.elevation,"bck_"..self.go.id)
						local openfront = findEntity("oft_"..self.go.id)
						if not openfront then
							openfront = spawn("sx_urban_town_door_02_openfront",self.go.level,nx,ny,(self.go.facing+1)%4,self.go.elevation,"oft_"..self.go.id)
							local openback = findEntity("obk_"..self.go.id)
							if not openback then
								dx,dy = getForward(openfront.facing)
								nx,ny = openfront.x+dx,openfront.y+dy
								if nx >= 0 and nx < self.go.map:getWidth() and ny >= 0 and ny < self.go.map:getHeight() then
									openback = spawn("sx_urban_town_door_openback",self.go.level,nx,ny,(openfront.facing+2)%4,self.go.elevation,"obk_"..self.go.id)
								end
							end
						end
					end
				end
			end,
			onInitialOpen = function(self)
				self:open()
			end,
			onInitialClose = function(self)
				-- nop
			end,
		},
	},
	editorIcon = 16,
	automapIcon = 84,
	dontAdjustHeight = true,
	tags = { "sx_doors" },
}



defineObject{
	name = "sx_urban_town_door_02_openfront",
	placement = "wall",
	components = {
		{
			class = "Model",
			model = "mod_assets/sx_swinging_doors/models/null_door.fbx",
			enabled = false,
		},
		{
			class = "Door",
			sparse = true,
			killPillars = false,
			openSound = "sx_silent",
			closeSound = "sx_silent",
			lockSound = "sx_silent",
			enabled = false,
		},
		{
			class = "Clickable",
			--debugDraw = "true",
			offset = vec(0.4,1.35,-0.4),
			size = vec(2.2, 1.4, 0.3),
			onClick = function(self)
				local door = findEntity(self.go.id:sub(5))
				if door and door.controller then door.controller:close() end
			end,
		},
	},
	automapIcon = -1,
}

defineObject{
	name = "sx_urban_town_door_openback",
	placement = "wall",
	components = {
		{
			class = "Model",
			model = "mod_assets/sx_swinging_doors/models/null_door.fbx",
			enabled = false,
		},
		{
			class = "Door",
			sparse = true,
			killPillars = false,
			openSound = "sx_silent",
			closeSound = "sx_silent",
			lockSound = "sx_silent",
			enabled = false,
		},
		{
			class = "Clickable",
			--debugDraw = "true",
			offset = vec(-0.2,1.35,0),
			size = vec(1.6, 1.4, 0.3),
			onClick = function(self)
				local door = findEntity(self.go.id:sub(5))
				if door and door.controller then door.controller:close() end
			end,
		},
	},
	automapIcon = -1,
}


defineObject{
	name = "sx_urban_town_door_back",
	placement = "wall",
	components = {
		{
			class = "Clickable",
			--debugDraw = "true",
			offset = vec(0,1.375,0),
			size = vec(2.0, 2.0, 0.3),
			onClick = function(self)
				local door = findEntity(self.go.id:sub(5))
				if door and door.controller then door.controller:open() end
			end,
		},
	},
}

defineAnimationEvent{
	animation = "mod_assets/sx_swinging_doors/animations/sx_swinging_door_02_open.fbx",
	event = "begin",
	normalizedTime = 0,
}
defineAnimationEvent{
	animation = "mod_assets/sx_swinging_doors/animations/sx_swinging_door_02_close.fbx",
	event = "begin",
	normalizedTime = 0,
}
defineAnimationEvent{
	animation = "mod_assets/sx_swinging_doors/animations/sx_swinging_door_02_open.fbx",
	event = "open",
	--frame = 11,
	normalizedTime = 0,
}
defineAnimationEvent{
	animation = "mod_assets/sx_swinging_doors/animations/sx_swinging_door_02_open.fbx",
	event = "midopen",
	frame = 24,
}
defineAnimationEvent{
	animation = "mod_assets/sx_swinging_doors/animations/sx_swinging_door_02_close.fbx",
	event = "close",
	--frame = 9,
	normalizedTime = 0,
}
defineAnimationEvent{
	animation = "mod_assets/sx_swinging_doors/animations/sx_swinging_door_02_open.fbx",
	event = "end",
	normalizedTime = 1,
}
defineAnimationEvent{
	animation = "mod_assets/sx_swinging_doors/animations/sx_swinging_door_02_open.fbx",
	event = "finishopen",
	normalizedTime = 1,
}
defineAnimationEvent{
	animation = "mod_assets/sx_swinging_doors/animations/sx_swinging_door_02_close.fbx",
	event = "end",
	normalizedTime = 1,
}
defineAnimationEvent{
	animation = "mod_assets/sx_swinging_doors/animations/sx_swinging_door_02_open.fbx",
	event = "playSound:sx_door",
	normalizedTime = 0,
}
defineAnimationEvent{
	animation = "mod_assets/sx_swinging_doors/animations/sx_swinging_door_02_close.fbx",
	event = "playSound:sx_door",
	normalizedTime = 0,
}


-- Sounds for the doors
defineSound{
	name = "sx_silent",
	filename = {
		"mod_assets/sx_swinging_doors/sounds/silent.wav",
	},
	loop = false,
	volume = 0.1,
}

defineSound{
	name = "sx_door",
	filename = {
		"mod_assets/sx_swinging_doors/sounds/sx_door.wav",
	},
	loop = false,
	volume = 1.0,
}

-- transperant texture to expand the bounding and prevent occlusion culling

defineMaterial{
	name = "sx_translucent",
	diffuseMap = "assets/textures/common/black_translucent.tga",
	doubleSided = false,
	lighting = true,
	alphaTest = true,
	castShadow = false,
	blendMode = "Translucent",
	textureAddressMode = "Wrap",
	glossiness = 0,
	depthBias = 0,
}